require "mscorlib"
require "System.Windows.Forms"
require "System.Drawing"


class FormPreferenceDialog < System::Windows::Forms::Form

  def initialize()
    self.InitializeComponent()
    @num_resolution = 24
    @num_pass = 2
    @num_cuttersize = 0.24
    @num_patternfeed = 30.0
    @num_patterndepth = 0.1
    @num_outlinefeed = 80.0
    @num_outlinelayer = 0.4
    @num_boardthin = 1.62
    @num_drilldepth = 1.70
    @num_drilldwell = 0
    @num_drillinputfix = 4
    @num_threadnum = 2
  end

  attr_accessor :num_resolution
  attr_accessor :num_pass
  attr_accessor :num_cuttersize
  attr_accessor :num_patternfeed
  attr_accessor :num_patterndepth
  attr_accessor :num_outlinefeed
  attr_accessor :num_outlinelayer
  attr_accessor :num_boardthin
  attr_accessor :num_drilldepth
  attr_accessor :num_drilldwell
  attr_accessor :num_drillinputfix
  attr_accessor :num_threadnum
  
  def InitializeComponent()
    @textBox_resolution = System::Windows::Forms::TextBox.new()
    @label1 = System::Windows::Forms::Label.new()
    @label2 = System::Windows::Forms::Label.new()
    @textBox_pass = System::Windows::Forms::TextBox.new()
    @textBox_cuttersize = System::Windows::Forms::TextBox.new()
    @textBox_patternfeed = System::Windows::Forms::TextBox.new()
    @textBox_patterndepth = System::Windows::Forms::TextBox.new()
    @textBox_outlinefeed = System::Windows::Forms::TextBox.new()
    @textBox_outlinelayer = System::Windows::Forms::TextBox.new()
    @button1 = System::Windows::Forms::Button.new()
    @button2 = System::Windows::Forms::Button.new()
    @label3 = System::Windows::Forms::Label.new()
    @label4 = System::Windows::Forms::Label.new()
    @label5 = System::Windows::Forms::Label.new()
    @label6 = System::Windows::Forms::Label.new()
    @label7 = System::Windows::Forms::Label.new()
    @label8 = System::Windows::Forms::Label.new()
    @label9 = System::Windows::Forms::Label.new()
    @textBox_boardthin = System::Windows::Forms::TextBox.new()
    @label10 = System::Windows::Forms::Label.new()
    @label11 = System::Windows::Forms::Label.new()
    @textBox_drillDepth = System::Windows::Forms::TextBox.new()
    @label12 = System::Windows::Forms::Label.new()
    @textBox_drillDwell = System::Windows::Forms::TextBox.new()
    @label13 = System::Windows::Forms::Label.new()
    @textBox_drillInputFix = System::Windows::Forms::TextBox.new()
    @label14 = System::Windows::Forms::Label.new()
    @label15 = System::Windows::Forms::Label.new()
    @textBox_threadNum = System::Windows::Forms::TextBox.new()
    @label16 = System::Windows::Forms::Label.new()
    self.SuspendLayout()
    # 
    # textBox_resolution
    # 
    @textBox_resolution.Location = System::Drawing::Point.new(12, 12)
    @textBox_resolution.Name = "textBox_resolution"
    @textBox_resolution.Size = System::Drawing::Size.new(55, 19)
    @textBox_resolution.TabIndex = 2
    @textBox_resolution.Text = "0"
    @textBox_resolution.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # label1
    # 
    @label1.Location = System::Drawing::Point.new(130, 15)
    @label1.Name = "label1"
    @label1.Size = System::Drawing::Size.new(163, 16)
    @label1.TabIndex = 10
    @label1.Text = "Round resolution"
    # 
    # label2
    # 
    @label2.Location = System::Drawing::Point.new(74, 65)
    @label2.Name = "label2"
    @label2.Size = System::Drawing::Size.new(32, 15)
    @label2.TabIndex = 11
    @label2.Text = "mm"
    # 
    # textBox_pass
    # 
    @textBox_pass.Location = System::Drawing::Point.new(12, 37)
    @textBox_pass.Name = "textBox_pass"
    @textBox_pass.Size = System::Drawing::Size.new(55, 19)
    @textBox_pass.TabIndex = 3
    @textBox_pass.Text = "0"
    @textBox_pass.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # textBox_cuttersize
    # 
    @textBox_cuttersize.Location = System::Drawing::Point.new(12, 62)
    @textBox_cuttersize.Name = "textBox_cuttersize"
    @textBox_cuttersize.Size = System::Drawing::Size.new(55, 19)
    @textBox_cuttersize.TabIndex = 4
    @textBox_cuttersize.Text = "0"
    @textBox_cuttersize.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # textBox_patternfeed
    # 
    @textBox_patternfeed.Location = System::Drawing::Point.new(12, 87)
    @textBox_patternfeed.Name = "textBox_patternfeed"
    @textBox_patternfeed.Size = System::Drawing::Size.new(55, 19)
    @textBox_patternfeed.TabIndex = 5
    @textBox_patternfeed.Text = "0"
    @textBox_patternfeed.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # textBox_patterndepth
    # 
    @textBox_patterndepth.Location = System::Drawing::Point.new(12, 112)
    @textBox_patterndepth.Name = "textBox_patterndepth"
    @textBox_patterndepth.Size = System::Drawing::Size.new(55, 19)
    @textBox_patterndepth.TabIndex = 6
    @textBox_patterndepth.Text = "0"
    @textBox_patterndepth.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # textBox_outlinefeed
    # 
    @textBox_outlinefeed.Location = System::Drawing::Point.new(12, 137)
    @textBox_outlinefeed.Name = "textBox_outlinefeed"
    @textBox_outlinefeed.Size = System::Drawing::Size.new(55, 19)
    @textBox_outlinefeed.TabIndex = 7
    @textBox_outlinefeed.Text = "0"
    @textBox_outlinefeed.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # textBox_outlinelayer
    # 
    @textBox_outlinelayer.Location = System::Drawing::Point.new(12, 162)
    @textBox_outlinelayer.Name = "textBox_outlinelayer"
    @textBox_outlinelayer.Size = System::Drawing::Size.new(55, 19)
    @textBox_outlinelayer.TabIndex = 8
    @textBox_outlinelayer.Text = "0"
    @textBox_outlinelayer.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # button1
    # 
    @button1.DialogResult = System::Windows::Forms::DialogResult.Cancel
    @button1.Location = System::Drawing::Point.new(285, 322)
    @button1.Name = "button1"
    @button1.Size = System::Drawing::Size.new(75, 23)
    @button1.TabIndex = 0
    @button1.Text = "Cancal"
    @button1.UseVisualStyleBackColor = true
    # 
    # button2
    # 
    @button2.DialogResult = System::Windows::Forms::DialogResult.OK
    @button2.Location = System::Drawing::Point.new(202, 322)
    @button2.Name = "button2"
    @button2.Size = System::Drawing::Size.new(75, 23)
    @button2.TabIndex = 1
    @button2.Text = "OK"
    @button2.UseVisualStyleBackColor = true
    # 
    # label3
    # 
    @label3.Location = System::Drawing::Point.new(130, 65)
    @label3.Name = "label3"
    @label3.Size = System::Drawing::Size.new(163, 16)
    @label3.TabIndex = 12
    @label3.Text = "Pattern cutter size"
    @label3.Click { |sender, e| self.Label3Click(sender, e) }
    # 
    # label4
    # 
    @label4.Location = System::Drawing::Point.new(130, 89)
    @label4.Name = "label4"
    @label4.Size = System::Drawing::Size.new(163, 16)
    @label4.TabIndex = 13
    @label4.Text = "Pattern carving feed speed"
    # 
    # label5
    # 
    @label5.Location = System::Drawing::Point.new(130, 114)
    @label5.Name = "label5"
    @label5.Size = System::Drawing::Size.new(163, 16)
    @label5.TabIndex = 14
    @label5.Text = "Pattern carving depth"
    # 
    # label6
    # 
    @label6.Location = System::Drawing::Point.new(130, 140)
    @label6.Name = "label6"
    @label6.Size = System::Drawing::Size.new(163, 16)
    @label6.TabIndex = 15
    @label6.Text = "Outline cutting feed speed"
    # 
    # label7
    # 
    @label7.Location = System::Drawing::Point.new(130, 165)
    @label7.Name = "label7"
    @label7.Size = System::Drawing::Size.new(163, 16)
    @label7.TabIndex = 16
    @label7.Text = "Outline cutting layer depth"
    # 
    # label8
    # 
    @label8.Location = System::Drawing::Point.new(130, 192)
    @label8.Name = "label8"
    @label8.Size = System::Drawing::Size.new(163, 16)
    @label8.TabIndex = 17
    @label8.Text = "Board thin"
    # 
    # label9
    # 
    @label9.Location = System::Drawing::Point.new(74, 89)
    @label9.Name = "label9"
    @label9.Size = System::Drawing::Size.new(51, 16)
    @label9.TabIndex = 18
    @label9.Text = "mm/min"
    # 
    # textBox_boardthin
    # 
    @textBox_boardthin.Location = System::Drawing::Point.new(12, 189)
    @textBox_boardthin.Name = "textBox_boardthin"
    @textBox_boardthin.Size = System::Drawing::Size.new(55, 19)
    @textBox_boardthin.TabIndex = 9
    @textBox_boardthin.Text = "0"
    @textBox_boardthin.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # label10
    # 
    @label10.Location = System::Drawing::Point.new(130, 40)
    @label10.Name = "label10"
    @label10.Size = System::Drawing::Size.new(163, 16)
    @label10.TabIndex = 19
    @label10.Text = "Pattern carving pass times"
    # 
    # label11
    # 
    @label11.Location = System::Drawing::Point.new(74, 114)
    @label11.Name = "label11"
    @label11.Size = System::Drawing::Size.new(32, 15)
    @label11.TabIndex = 20
    @label11.Text = "mm"
    # 
    # textBox_drillDepth
    # 
    @textBox_drillDepth.Location = System::Drawing::Point.new(12, 214)
    @textBox_drillDepth.Name = "textBox_drillDepth"
    @textBox_drillDepth.Size = System::Drawing::Size.new(55, 19)
    @textBox_drillDepth.TabIndex = 21
    @textBox_drillDepth.Text = "0"
    @textBox_drillDepth.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # label12
    # 
    @label12.Location = System::Drawing::Point.new(130, 217)
    @label12.Name = "label12"
    @label12.Size = System::Drawing::Size.new(163, 16)
    @label12.TabIndex = 22
    @label12.Text = "Drill depth"
    # 
    # textBox_drillDwell
    # 
    @textBox_drillDwell.Location = System::Drawing::Point.new(12, 239)
    @textBox_drillDwell.Name = "textBox_drillDwell"
    @textBox_drillDwell.Size = System::Drawing::Size.new(55, 19)
    @textBox_drillDwell.TabIndex = 23
    @textBox_drillDwell.Text = "0"
    @textBox_drillDwell.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # label13
    # 
    @label13.Location = System::Drawing::Point.new(130, 242)
    @label13.Name = "label13"
    @label13.Size = System::Drawing::Size.new(163, 16)
    @label13.TabIndex = 24
    @label13.Text = "Drill dwell "
    @label13.Click { |sender, e| self.Label13Click(sender, e) }
    # 
    # textBox_drillInputFix
    # 
    @textBox_drillInputFix.Location = System::Drawing::Point.new(12, 264)
    @textBox_drillInputFix.Name = "textBox_drillInputFix"
    @textBox_drillInputFix.Size = System::Drawing::Size.new(55, 19)
    @textBox_drillInputFix.TabIndex = 25
    @textBox_drillInputFix.Text = "0"
    @textBox_drillInputFix.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # label14
    # 
    @label14.Location = System::Drawing::Point.new(130, 267)
    @label14.Name = "label14"
    @label14.Size = System::Drawing::Size.new(163, 16)
    @label14.TabIndex = 26
    @label14.Text = "Drill input fix point"
    # 
    # label15
    # 
    @label15.Location = System::Drawing::Point.new(74, 243)
    @label15.Name = "label15"
    @label15.Size = System::Drawing::Size.new(32, 15)
    @label15.TabIndex = 27
    @label15.Text = "msec"
    # 
    # textBox_threadNum
    # 
    @textBox_threadNum.Location = System::Drawing::Point.new(12, 289)
    @textBox_threadNum.Name = "textBox_threadNum"
    @textBox_threadNum.Size = System::Drawing::Size.new(55, 19)
    @textBox_threadNum.TabIndex = 28
    @textBox_threadNum.Text = "2"
    @textBox_threadNum.TextAlign = System::Windows::Forms::HorizontalAlignment.Right
    # 
    # label16
    # 
    @label16.Location = System::Drawing::Point.new(130, 289)
    @label16.Name = "label16"
    @label16.Size = System::Drawing::Size.new(163, 16)
    @label16.TabIndex = 29
    @label16.Text = "Build thread num"
    # 
    # Form1
    # 
    self.ClientSize = System::Drawing::Size.new(370, 360)
    self.Controls.Add(@label16)
    self.Controls.Add(@textBox_threadNum)
    self.Controls.Add(@label15)
    self.Controls.Add(@textBox_drillInputFix)
    self.Controls.Add(@label14)
    self.Controls.Add(@textBox_drillDwell)
    self.Controls.Add(@label13)
    self.Controls.Add(@textBox_drillDepth)
    self.Controls.Add(@label12)
    self.Controls.Add(@label11)
    self.Controls.Add(@label10)
    self.Controls.Add(@textBox_boardthin)
    self.Controls.Add(@label9)
    self.Controls.Add(@label8)
    self.Controls.Add(@label7)
    self.Controls.Add(@label6)
    self.Controls.Add(@label5)
    self.Controls.Add(@label4)
    self.Controls.Add(@label3)
    self.Controls.Add(@button2)
    self.Controls.Add(@button1)
    self.Controls.Add(@textBox_outlinelayer)
    self.Controls.Add(@textBox_outlinefeed)
    self.Controls.Add(@textBox_patterndepth)
    self.Controls.Add(@textBox_patternfeed)
    self.Controls.Add(@textBox_cuttersize)
    self.Controls.Add(@textBox_pass)
    self.Controls.Add(@label2)
    self.Controls.Add(@label1)
    self.Controls.Add(@textBox_resolution)
    self.MaximizeBox = false
    self.MinimizeBox = false
    self.Name = "FormPreferenceDialog"
    self.ShowIcon = false
    self.ShowInTaskbar = false
    self.FormBorderStyle = System::Windows::Forms::FormBorderStyle.FixedDialog
    self.StartPosition = System::Windows::Forms::FormStartPosition.CenterParent
    self.Text = "Preference"
    self.FormClosed{ on_close }
    self.ResumeLayout(false)
    self.PerformLayout()
  end

  def ShowDialog
    @textBox_resolution.Text   = @num_resolution.to_s
    @textBox_pass.Text         = @num_pass.to_s
    @textBox_cuttersize.Text   = @num_cuttersize.to_s
    @textBox_patternfeed.Text  = @num_patternfeed.to_s
    @textBox_patterndepth.Text = @num_patterndepth.to_s
    @textBox_outlinefeed.Text  = @num_outlinefeed.to_s
    @textBox_outlinelayer.Text = @num_outlinelayer.to_s
    @textBox_boardthin.Text    = @num_boardthin.to_s
    @textBox_drillDepth.Text   = @num_drilldepth.to_s
    @textBox_drillDwell.Text   = @num_drilldwell.to_s
    @textBox_drillInputFix.Text = @num_drillinputfix.to_s
    @textBox_threadNum.Text = @num_threadnum.to_s
    super
  end

  def on_close
    begin
      @num_resolution   = @textBox_resolution.Text.to_i
      @num_pass         = @textBox_pass.Text.to_i
      @num_cuttersize   = @textBox_cuttersize.Text.to_f
      @num_patternfeed  = @textBox_patternfeed.Text.to_f
      @num_patterndepth = @textBox_patterndepth.Text.to_f
      @num_outlinefeed  = @textBox_outlinefeed.Text.to_f
      @num_outlinelayer = @textBox_outlinelayer.Text.to_f
      @num_boardthin    = @textBox_boardthin.Text.to_f
      @num_drilldepth   = @textBox_drillDepth.Text.to_f
      @num_drilldwell   = @textBox_drillDwell.Text.to_i
      @num_drillinputfix = @textBox_drillInputFix.Text.to_i
      @num_threadnum = @textBox_threadNum.Text.to_i
    rescue
    end
  end
end
